# CfnAssociation

The `AWS::SSM::Association` resource creates a State Manager association for your managed instances.

A State Manager association defines the state that you want to maintain on your instances. For example, an association can specify that anti-virus software must be installed and running on your instances, or that certain ports must be closed. For static targets, the association specifies a schedule for when the configuration is reapplied. For dynamic targets, such as an Resource Groups or an AWS Auto Scaling Group, State Manager applies the configuration when new instances are added to the group. The association also specifies actions to take when applying the configuration. For example, an association for anti-virus software might run once a day. If the software is not installed, then State Manager installs it. If the software is installed, but the service is not running, then the association might instruct State Manager to start the service.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnAssociation
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IAssociationRef, IConstruct, IDependable

- CloudFormation: [`AWS::SSM::Association`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-ssm-association.html)
- Source: Generated code
- Type last changed: v2.260.0 · 16 Jun 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_ssm as ssm } from 'aws-cdk-lib';

declare const parameters: any;
const cfnAssociation = new ssm.CfnAssociation(this, 'MyCfnAssociation', {
  name: 'name',

  // the properties below are optional
  applyOnlyAtCronInterval: false,
  associationDispatchAssumeRole: 'associationDispatchAssumeRole',
  associationName: 'associationName',
  automationTargetParameterName: 'automationTargetParameterName',
  calendarNames: ['calendarNames'],
  complianceSeverity: 'complianceSeverity',
  documentVersion: 'documentVersion',
  instanceId: 'instanceId',
  maxConcurrency: 'maxConcurrency',
  maxErrors: 'maxErrors',
  outputLocation: {
    s3Location: {
      outputS3BucketName: 'outputS3BucketName',
      outputS3KeyPrefix: 'outputS3KeyPrefix',
      outputS3Region: 'outputS3Region',
    },
  },
  parameters: parameters,
  scheduleExpression: 'scheduleExpression',
  scheduleOffset: 123,
  syncCompliance: 'syncCompliance',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  targets: [{
    key: 'key',
    values: ['values'],
  }],
  waitForSuccessTimeoutSeconds: 123,
});
```

## Initializer

```ts
new CfnAssociation(scope: Construct, id: string, props: CfnAssociationProps)
```

## Construct Props

- `applyOnlyAtCronInterval`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — By default, when you create a new association, the system runs it immediately after it is created and then according to the schedule you specified.

  Specify this option if you don't want an association to run immediately after you create it. This parameter is not supported for rate expressions.

- `associationDispatchAssumeRole`: string — A role used by association to take actions on your behalf.

- `associationName`: string — Specify a descriptive name for the association.

- `automationTargetParameterName`: string — Choose the parameter that will define how your automation will branch out.

  This target is required for associations that use an Automation runbook and target resources by using rate controls. Automation is a tool in AWS Systems Manager .

- `calendarNames`: string[] — The names or Amazon Resource Names (ARNs) of the Change Calendar type documents your associations are gated under.

  The associations only run when that Change Calendar is open. For more information, see [AWS Systems Manager Change Calendar](https://docs.aws.amazon.com/systems-manager/latest/userguide/systems-manager-change-calendar) in the *AWS Systems Manager User Guide* .

- `complianceSeverity`: string — The severity level that is assigned to the association.

- `documentVersion`: string — The version of the SSM document to associate with the target.

  > Note the following important information.
  >
  > - State Manager doesn't support running associations that use a new version of a document if that document is shared from another account. State Manager always runs the `default` version of a document if shared from another account, even though the Systems Manager console shows that a new version was processed. If you want to run an association using a new version of a document shared form another account, you must set the document version to `default` .
  > - `DocumentVersion` is not valid for documents owned by AWS , such as `AWS-RunPatchBaseline` or `AWS-UpdateSSMAgent` . If you specify `DocumentVersion` for an AWS document, the system returns the following error: "Error occurred during operation 'CreateAssociation'." (RequestToken: <token>, HandlerErrorCode: GeneralServiceException).

- `instanceId`: string — > `InstanceId` has been deprecated.

  To specify an instance ID for an association, use the `Targets` parameter. If you use the parameter `InstanceId` , you cannot use the parameters `AssociationName` , `DocumentVersion` , `MaxErrors` , `MaxConcurrency` , `OutputLocation` , or `ScheduleExpression` . To use these parameters, you must use the `Targets` parameter.
  >
  > Note that in some examples later in this page, `InstanceIds` is used as the tag-key name in a `Targets` filter. `InstanceId` is not used as a parameter.

  The ID of the instance that the SSM document is associated with. You must specify the `InstanceId` or `Targets` property.

- `maxConcurrency`: string — The maximum number of targets allowed to run the association at the same time.

  You can specify a number, for example 10, or a percentage of the target set, for example 10%. The default value is 100%, which means all targets run the association at the same time.

  If a new managed node starts and attempts to run an association while Systems Manager is running `MaxConcurrency` associations, the association is allowed to run. During the next association interval, the new managed node will process its association within the limit specified for `MaxConcurrency` .

- `maxErrors`: string — The number of errors that are allowed before the system stops sending requests to run the association on additional targets.

  You can specify either an absolute number of errors, for example 10, or a percentage of the target set, for example 10%. If you specify 3, for example, the system stops sending requests when the fourth error is received. If you specify 0, then the system stops sending requests after the first error is returned. If you run an association on 50 managed nodes and set `MaxError` to 10%, then the system stops sending the request when the sixth error is received.

  Executions that are already running an association when `MaxErrors` is reached are allowed to complete, but some of these executions may fail as well. If you need to ensure that there won't be more than max-errors failed executions, set `MaxConcurrency` to 1 so that executions proceed one at a time.

- `name`: string | [IDocumentRef](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ssm.IDocumentRef.html) (required) — The name of the SSM document that contains the configuration information for the instance.

  You can specify `Command` or `Automation` documents. The documents can be AWS -predefined documents, documents you created, or a document that is shared with you from another account. For SSM documents that are shared with you from other AWS accounts , you must specify the complete SSM document ARN, in the following format:

  `arn:partition:ssm:region:account-id:document/document-name`

  For example: `arn:aws:ssm:us-east-2:12345678912:document/My-Shared-Document`

  For AWS -predefined documents and SSM documents you created in your account, you only need to specify the document name. For example, `AWS -ApplyPatchBaseline` or `My-Document` .

- `outputLocation`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnAssociation.InstanceAssociationOutputLocationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ssm.CfnAssociation.InstanceAssociationOutputLocationProperty.html) — An Amazon Simple Storage Service (Amazon S3) bucket where you want to store the output details of the request.

- `parameters`: any — The parameters for the runtime configuration of the document.

- `scheduleExpression`: string — A cron expression that specifies a schedule when the association runs.

  The schedule runs in Coordinated Universal Time (UTC).

- `scheduleOffset`: number — Number of days to wait after the scheduled day to run an association.

- `syncCompliance`: string — The mode for generating association compliance.

  You can specify `AUTO` or `MANUAL` . In `AUTO` mode, the system uses the status of the association execution to determine the compliance status. If the association execution runs successfully, then the association is `COMPLIANT` . If the association execution doesn't run successfully, the association is `NON-COMPLIANT` .

  In `MANUAL` mode, you must specify the `AssociationId` as a parameter for the `PutComplianceItems` API action. In this case, compliance data is not managed by State Manager. It is managed by your direct call to the `PutComplianceItems` API action.

  By default, all associations use `AUTO` mode.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A key-value pair to associate with a resource.

- `targets`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnAssociation.TargetProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ssm.CfnAssociation.TargetProperty.html)[] — The targets for the association.

  You must specify the `InstanceId` or `Targets` property. You can target all instances in an AWS account by specifying t he `InstanceIds` key with a value of `*` .

  Supported formats include the following.

  - `Key=InstanceIds,Values=<instance-id-1>,<instance-id-2>,<instance-id-3>`
  - `Key=tag-key,Values=<my-tag-key-1>,<my-tag-key-2>`

  To view a JSON and a YAML example that targets all instances, see "Create an association for all managed instances in an AWS account " on the Examples page.

- `waitForSuccessTimeoutSeconds`: number — The number of seconds the service should wait for the association status to show "Success" before proceeding with the stack execution.

  If the association status doesn't show "Success" after the specified number of seconds, then stack creation fails.

  > When you specify a value for the `WaitForSuccessTimeoutSeconds` , [drift detection](https://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/using-cfn-stack-drift.html) for your CloudFormation stack’s configuration might yield inaccurate results. If drift detection is important in your scenario, we recommend that you don’t include `WaitForSuccessTimeoutSeconds` in your template.

## Properties

- `applyOnlyAtCronInterval`: boolean | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) — By default, when you create a new association, the system runs it immediately after it is created and then according to the schedule you specified.

- `associationDispatchAssumeRole`: string — A role used by association to take actions on your behalf.

- `associationName`: string — Specify a descriptive name for the association.

- `associationRef`: [AssociationReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_ssm.AssociationReference.html) — A reference to a Association resource.

- `attrAssociationId`: string — The association ID.

- `automationTargetParameterName`: string — Choose the parameter that will define how your automation will branch out.

- `calendarNames`: string[] — The names or Amazon Resource Names (ARNs) of the Change Calendar type documents your associations are gated under.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `complianceSeverity`: string — The severity level that is assigned to the association.

- `creationStack`: string[]

- `documentVersion`: string — The version of the SSM document to associate with the target.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `instanceId`: string — > `InstanceId` has been deprecated.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `maxConcurrency`: string — The maximum number of targets allowed to run the association at the same time.

- `maxErrors`: string — The number of errors that are allowed before the system stops sending requests to run the association on additional targets.

- `name`: string — The name of the SSM document that contains the configuration information for the instance.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `outputLocation`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnAssociation.InstanceAssociationOutputLocationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ssm.CfnAssociation.InstanceAssociationOutputLocationProperty.html) — An Amazon Simple Storage Service (Amazon S3) bucket where you want to store the output details of the request.

- `parameters`: any — The parameters for the runtime configuration of the document.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `scheduleExpression`: string — A cron expression that specifies a schedule when the association runs.

- `scheduleOffset`: number — Number of days to wait after the scheduled day to run an association.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `syncCompliance`: string — The mode for generating association compliance.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A key-value pair to associate with a resource.

- `targets`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnAssociation.TargetProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_ssm.CfnAssociation.TargetProperty.html)[] — The targets for the association.

- `waitForSuccessTimeoutSeconds`: number — The number of seconds the service should wait for the association status to show "Success" before proceeding with the stack execution.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForAssociation(resource: IAssociationRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `fromAssociationId(scope: Construct, id: string, associationId: string): IAssociationRef` (static) — Creates a new IAssociationRef from a associationId.

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnAssociation(x: any): boolean` (static) — Checks whether the given object is a CfnAssociation.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
